###########################################################################################################################################
###################### /*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::. ##########################
#################### /mMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMNd- ########################
################### -MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMN` #######################
################### /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMmNMMMMMMMMMMMmMMMMMMMMMMMMMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMh:NMMMMMMMMMMoyMMMMMMMMMMMMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMm -NMMMMMMMMMs.NMMMMMMMMMMMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMy  -hmmmmmNNm- sMMMMMMMMMMMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMmdyo+:`   ```````.`  .NMMMymMMMMMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMmy+-.`                    -hNm-+MMMMMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMms:`                          `.. /MMMMMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMh/.                                 /MMMMMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMMmMMMMMMMMMMMmhN:`                                   /MMMMMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMM+sNMMMMMMMMMN-h:         `-+syyys/-                 -NMMMMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMMs +NMMMMMMMhm--d`  :.  -sdNMMMMMNNmy.                :ydMMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMM+  :yhyyyhhso` os  yhshNMMMMMMMh+:-:.  :s-             .NMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMmho`          `   `yo.h:sMMMMMMMMMMNd+.   -NNs-            yMMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMMMNh/.                   :++`-MMMMMMMMMMMMMm+`  :ymds.          -NMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMMMmo-                          .MMMMMMMMMMMMMMMdo.  `.-`           yMMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMMMmo.                            `NMMMMMMMMMMMMMMMMNy/.`             `mMMMMMMMMMMMMMMM- #######################
################### /MMMMMMMNs.                               hMMMMMMMMMMMMMMMMMMMNho-`           :NMMMMMMMMMMMMMM- #######################
################### /MMMMMMm:        ./syyyo-                 -hmNMMMMMMMMMMMMMMMMMMMMmho:.`       /NMMMMMMMMMMMMM- #######################
################### /MMMMMd.       .smMMMNNNms`  `              `+MMMMMMMMMMMMMMMMMMMMMMMMNdy/    `.yMMMMMMMMMMMMM- #######################
################### /MMMMd.       /mMMMMMy/:--`  so.             `mMMMMMMMMMMMMMMMMMMMMMMMNdo--:+sdNMMMMMMMMMMMMMM- #######################
################### /MMMN-       /NMMMMMMMMdo.   oMm+.            /MMMMMMMMMMMMMMMMdNMMMMMMNNNMMmMMMMMMMMMMMMMMMMM- #######################
################### /MMMo       -NMMMMMMMMMMdso-` /hmm+            sMMMMMMMMMMMMMMMs-mMMMMMMMMMM:dMMMMMMMMMMMMMMMM- #######################
################### /MMN.       sMMMMMMMMMMMo .os/.``..            `dMMMMMMMMMMMMMMs -NMMMMMMMMM-:MMMMMMMMMMMMMMMM- #######################
################### /MMd        mMMMMMMMMMMM/   `:os+-`             .dMMMMMMMMMMMNm.  -soosyhdms `mMMMMMMMMMMMMMMM- #######################
################### /MMs        mMMMMMMMMMMM:       .hNhs/.`         .dMMMMNmhs+:-`               +MMMNoMMMMMMMMMM- #######################
################### /MMy        hMMMMMMMMMMM:        oMMMMMNdyo/.     .mNh+-`                      +mNy`mMMMMMMMMM- #######################
################### /MMd        +MMMMMMMMMMM/        :MMMMMMMMNs.`.:ohh/`                            `  mMMMMMMMMM- #######################
################### /MMN.       `mMMMMMMMMMMo        `NMMMMMMNhhdNMMh:                                  mMMMMMMMMM- #######################
################### /MMM+        /MMMMMMMMMMh         yMMMMMMMMMMMN+                                   `NMMMMMMMMM- #######################
################### /MMMm`        +MMMMMMMMMN`        .NMMMMMMMMMN-         :sdmNNNdy+`                 dMMMMMMMMM- #######################
################### /MMMMo         +MMMMMMMMM+         +MMMMMMMMM/        -dMMMMMMNmmNN/                .sdMMMMMMM- #######################
################### /MMMMN:         :mMMMMMMMm`         oMMMMMMMh        .mMMMMMMMms- ``  /o`             `mMMMMMM- #######################
################### /MMMMMm.         .yMMMMMMMo          oMMMMMM/        sMMMMMMMMMMMh:   :NNo.            sMMMMMM- #######################
################### /MMMMMMm.          -hMMMMMN:          /NMMMM.        dMMMMMMMMMMMMMh-  :hmNy`          .NMMMMM- #######################
################### /MMMMMMMm-           -yNMMMm.          .yMMM.        dMMMMMMMMMMMMMMNh:` `..`           yMMMMM- #######################
################### /MMMMMMMMN+            .+hNMd.           :hM:        dMMMMMMMMMMMMMMMMNmo-              .NMMMM- #######################
################### /MMMMMMMMMMh-             ./ss.           `::        sMMMMMMMMMMMMMMMMMMMNms/.           /MMMM- #######################
################### /MMMMMMMMMMMNo.              `                       :MMMMMMMMMMMMMMMMMMMMMMMNdo:.`       oMMM- #######################
################### /MMMMMMMMMMMMMmo.                                    `mMMMMMMMMMMMMMMMMMMMMMMMMMMNmh:     .dMM- #######################
################### /MMMMMMMMMMMMMMMNy:`                                  +MMMMMMMMMMMMMMMMMMMMMMMMMMNh+::/+sdNMMM- #######################
################### /MMMMMMMMMMMMMMMMMNdo-                                `dMMMMMMMMMMMMMMMMMMMMMMMMMNNNNNMMMMMMMM- #######################
################### /MMMMMMMMMMMMMMMMMMMMNd+-`                             -NMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM- #######################
################### -NMMMMMMMMMMMMMMMMMMMMMMNdo:`                           /NMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMd` #######################
#################### -ymNNNNNNNNNNNNNNNNNNNNNNNNdo-`                         +NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNmy. ########################
###################### ............................                           .-..............................*/ ##########################
####################### ``````       `````````          ``````````````          ``````````              ````` #############################
########################################################################################################################################### imports
import curses
####################################################################################################################################### SOF
import os
import shutil
import sys
from curses import (A_REVERSE, KEY_DOWN, KEY_ENTER, KEY_LEFT, KEY_RIGHT,
                    KEY_UP, ascii, wrapper)
from imghdr import what as is_file_an_image
from os import chdir, listdir, path
from pathlib import Path
from random import choice, randint, shuffle
from time import sleep
from tkinter import *
from tkinter import filedialog, font, ttk
from tkinter.filedialog import askopenfile
###########################################################################################################################################
from PIL import Image, ImageTk
from rich.color import ANSI_COLOR_NAMES
from rich.console import Console
########################################################################################################################################### globals
global STARTUP_DIRECTORY_OVERRIDE; STARTUP_DIRECTORY_OVERRIDE=['/Users/dr1p/dr1p1m4g3/grids']
########################################################################################################################################### class dr1p1m4g3
class DR1P1M4G3():
  ######################################################################################################################################### __init__ <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< __init__ class
  def __init__(self,USERPATH=None,IMGINDEX=None,RENDMODE=None,PUMPMODE=None,PUMPTIME=None,USERSHUF=None):
    #######################################################################################################################################
    if USERPATH:
      self.DIR_IMAGE_LIST=USERPATH
      self.IMAGE_DIR_INDEX=[]
      self.USER_USERPATH=USERPATH
    else:
      self.USER_USERPATH=""
      self.IMAGE_DIR="./"
    #######################################################################################################################################
    if IMGINDEX:
      self.IMAGE_INDEX=IMGINDEX
      self.USER_IMGINDEX=IMGINDEX
    else:
      self.USER_IMGINDEX=0
      self.IMAGE_INDEX=0
    #######################################################################################################################################
    if RENDMODE:
      self.REDIMENSION=RENDMODE
      self.USER_RENDMODE=RENDMODE
    else:
      self.USER_RENDMODE=0
      self.REDIMENSION=0
    #######################################################################################################################################
    if PUMPMODE:
      self.PUMPMODE=PUMPMODE
      self.USER_PUMPMODE=PUMPMODE
    else:
      self.USER_PUMPMODE=False
      self.PUMP_AUTO=False
    #######################################################################################################################################
    if not PUMPTIME==float(0.5):
      self.PUMPTIME=PUMPTIME
      self.USER_PUMPTIME=PUMPTIME
      self.PUMP_INTERVAL=0.5
    else:
      self.USER_PUMPTIME=0
      self.PUMP_INTERVAL=0.5
    #######################################################################################################################################
    if USERSHUF:
      self.USERSHUF=USERSHUF
      self.USER_USERSHUF=False
    else:
      self.USERSHUF=False
      self.USER_USERSHUF=False
    #######################################################################################################################################
    self.LOGINIT=0
    self.LOGFILE="dr1pt_pr0be.log"
    self.REFRESH=0
    self.RENDER_TEXT=True
    self.LAST_DIRECTION=-1
    self.ISAVE_DIRECTORY=[ str(f'{x}_ISAVE') for x in self.DIR_IMAGE_LIST ]
    self.IDROP_DIRECTORY=[ str(f'{x}_IDROP') for x in self.DIR_IMAGE_LIST ]
    self.IMAGE_LIST=[]
    self.MARKED_FILES=[]
    self.MARKED=False
    self.gx=0
    self.gy=0
    self.GX=10
    self.GY=10
    self.xy=[0,0]
    self.GRID_MODE=False
    self.moverect=''
    self.cellrect=[0,[],[]]
    self.XX=0
    self.YY=0
    self.NORMAL_TEXT_COLOR=f'#{hex(randint(0,255))[2:].zfill(2)}{hex(randint(0,255))[2:].zfill(2)}{hex(randint(0,255))[2:].zfill(2)}'
    self.NORMAL_TEXT_FONTS=['Academy Engraved LET', 'Al Bayan', 'Al Nile', 'Al Tarikh', 'American Typewriter', 'Andale Mono', 'Apple Braille', 'Apple Chancery', 'Apple Color Emoji', 'Apple SD Gothic Neo', 'Apple Symbols', 'AppleGothic', 'AppleMyungjo', 'Arial', 'Arial Black', 'Arial Hebrew', 'Arial Hebrew Scholar', 'Arial Narrow', 'Arial Rounded MT Bold', 'Arial Unicode MS', 'Avenir', 'Avenir Next', 'Avenir Next Condensed', 'Ayuthaya', 'Baghdad', 'Bangla MN', 'Bangla Sangam MN', 'Baskerville', 'Beirut', 'Big Caslon', 'Bodoni 72', 'Bodoni 72 Oldstyle', 'Bodoni 72 Smallcaps', 'Bodoni Ornaments', 'Bradley Hand', 'Brush Script MT', 'Chalkboard', 'Chalkboard SE', 'Chalkduster', 'Charter', 'Cochin', 'Comic Sans MS', 'Copperplate', 'Corsiva Hebrew', 'Courier New', 'Damascus', 'DecoType Naskh', 'Devanagari MT', 'Devanagari Sangam MN', 'Didot', 'DIN Alternate', 'DIN Condensed', 'Diwan Kufi', 'Diwan Thuluth', 'Euphemia UCAS', 'Farah', 'Farisi', 'FiraCode Nerd Font', 'FiraCode Nerd Font Mono', 'FuraCode Nerd Font', 'FuraCode Nerd Font Mono', 'Futura', 'Galvji', 'GB18030 Bitmap', 'Geeza Pro', 'Geneva', 'Georgia', 'Gill Sans', 'Grantha Sangam MN', 'Gujarati MT', 'Gujarati Sangam MN', 'Gurmukhi MN', 'Gurmukhi MT', 'Gurmukhi Sangam MN', 'Heiti SC', 'Heiti TC', 'Helvetica', 'Helvetica Neue', 'Herculanum', 'Hiragino Maru Gothic ProN', 'Hiragino Mincho ProN', 'Hiragino Sans', 'Hiragino Sans GB', 'Hoefler Text', 'Impact', 'InaiMathi', 'ITF Devanagari', 'ITF Devanagari Marathi', 'Kailasa', 'Kannada MN', 'Kannada Sangam MN', 'Kefa', 'Khmer MN', 'Khmer Sangam MN', 'Kohinoor Bangla', 'Kohinoor Devanagari', 'Kohinoor Gujarati', 'Kohinoor Telugu', 'Kokonor', 'Krungthep', 'KufiStandardGK', 'Lao MN', 'Lao Sangam MN', 'Lucida Grande', 'Luminari', 'Malayalam MN', 'Malayalam Sangam MN', 'Marker Felt', 'Menlo', 'Microsoft Sans Serif', 'Mishafi', 'Mishafi Gold', 'Monaco', 'Mshtakan', 'Mukta Mahee', 'Muna', 'Myanmar MN', 'Myanmar Sangam MN', 'Nadeem', 'New Peninim MT', 'Noteworthy', 'Noto Nastaliq Urdu', 'Noto Sans Kannada', 'Noto Sans Myanmar', 'Noto Sans Oriya', 'Noto Serif Myanmar', 'Optima', 'Oriya MN', 'Oriya Sangam MN', 'Palatino', 'Papyrus', 'Party LET', 'Phosphate', 'PingFang HK', 'PingFang SC', 'PingFang TC', 'Plantagenet Cherokee', 'PT Mono', 'PT Sans', 'PT Sans Caption', 'PT Sans Narrow', 'PT Serif', 'PT Serif Caption', 'Raanana', 'Rockwell', 'Sana', 'Sathu', 'Savoye LET', 'Shree Devanagari 714', 'SignPainter', 'Silom', 'Sinhala MN', 'Sinhala Sangam MN', 'Skia', 'Snell Roundhand', 'Songti SC', 'Songti TC', 'Source Code Pro', 'STIX Two Math', 'STIX Two Text', 'STSong', 'Sukhumvit Set', 'Symbol', 'Tahoma', 'Tamil MN', 'Tamil Sangam MN', 'Telugu MN', 'Telugu Sangam MN', 'Thonburi', 'Times New Roman', 'Trattatello', 'Trebuchet MS', 'Verdana', 'Waseem', 'Webdings', 'Wingdings', 'Wingdings 2', 'Wingdings 3', 'Zapf Dingbats', 'Zapfino']
    self.NORMAL_TEXT_FONT=self.NORMAL_TEXT_FONTS[randint(0,len(self.NORMAL_TEXT_FONTS)-1)]
    self.NORMAL_TEXT_SIZE=25
    self.AUTOCOLOR={'N':[0,0,0],'L':[['blue2','red2','purple2'],['midnight blue','navy blue'],['goldenrod1','goldenrod2','goldenrod3']]}
    self.FIRST_INDEX=False
    self.AUTO_GRID=True
    self.logfile='resolutions_database.txt'
    self.colors=[]
    self.basename=0
    for _ in ANSI_COLOR_NAMES:
        if _.lower().find('black') == -1:
            self.colors.append(_)
    ###########
    self.main()
  ######################################################################################################################################### l0g
  def l0g(self,s):
    c=Console()
    if not self.LOGINIT:
      if path.isfile(self.LOGFILE): os.remove(self.LOGFILE)
      f=open(self.LOGFILE,'w');f.write('');f.close();self.LOGINIT=1;
    f=open(self.LOGFILE,'a');f.write(f'{s}\n');f.close();
    _s=s.split()
    s=''
    FULL_COLOR=False # False for half-color, True for full-color
    for _ in _s:
      color=choice(self.colors)
      msg=f'[{color}]{_}[/{color}]'
      s+=f'{msg} '
    c.print(s)
    if FULL_COLOR:
      _s=''
      for _ in s:
        color=choice(self.colors)
        msg=f'[{color}]{_}[/{color}]'
        _s+=f'{msg}'
      c.print(_s)
  ######################################################################################################################################### randofontcolors
  def randofontcolors(self,n):
    self.NORMAL_TEXT_COLOR=f'#{hex(randint(0,255))[2:].zfill(2)}{hex(randint(0,255))[2:].zfill(2)}{hex(randint(0,255))[2:].zfill(2)}'
    self.NORMAL_TEXT_FONTS=list(font.families())
    self.NORMAL_TEXT_FONT=self.NORMAL_TEXT_FONTS[randint(0,len(self.NORMAL_TEXT_FONTS)-1)]
    self.NORMAL_TEXT_SIZE=randint(15,35)
    [ self.canvas.delete(x) for x in self.canvas.find_all() if not 'activeimage' in self.canvas.itemconfig(x) ]
    Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],self.REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,self.root.winfo_screenwidth()-self.image.width,self.root.winfo_screenheight()-self.image.height,self.XX,self.YY,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
    Buffer+= f'\n{self.xy[0]}x{self.GX} / {self.xy[1]}y{self.GY}'
    [ self.canvas.delete(x) for x in self.canvas.find_all() if not 'activeimage' in self.canvas.itemconfig(x) ]
    self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2, 85, text=Buffer,fill=self.NORMAL_TEXT_COLOR,justify='center',font=(self.NORMAL_TEXT_FONT, self.NORMAL_TEXT_SIZE))
    self.root.title(Buffer)
    self.root.update()
  ######################################################################################################################################### autocolor
  def autocolor(self,n):
    try:
      self.AUTOCOLOR['N'][n]+=1
      if self.AUTOCOLOR['N'][n]>=len(self.AUTOCOLOR['L'][n]): self.AUTOCOLOR['N'][n]=0
      return self.AUTOCOLOR['L'][n][self.AUTOCOLOR['N'][n]]
    except:
      return -1.666
  ######################################################################################################################################### fliptext
  def fliptext(self,s):
    self.RENDER_TEXT=not self.RENDER_TEXT
    if self.RENDER_TEXT:
      self.l0g(f"<<<<< text rendering enabled >>>>>")
      self.canvas.delete('all')
      self.loadimage()
    else:
      self.l0g(f"<<<<< text rendering disabled >>>>>")
      self.canvas.delete('all')
      self.loadimage()
  ######################################################################################################################################### isave
  def isave(self,s):
    if not self.MARKED:
      if self.MARKED_FILES[self.IMAGE_INDEX]==1:
        self.l0g(f"<<<<< unmarking from save {self.IMAGE_LIST[self.IMAGE_INDEX]} >>>>>")
        self.MARKED_FILES[self.IMAGE_INDEX]=0
        self.loadimage()
        return
      else:
        self.l0g(f"<<<<< marked to save {self.IMAGE_LIST[self.IMAGE_INDEX]} >>>>>")
        self.MARKED_FILES[self.IMAGE_INDEX]=1
      if self.LAST_DIRECTION:
        self.right(self)
      else:
        self.left(self)
    else:
      for SIN,VAL in enumerate(self.MARKED_FILES):
        if VAL==1:
          if not os.path.exists(self.ISAVE_DIRECTORY[self.IMAGE_DIR_INDEX[SIN]]):
            os.mkdir(self.ISAVE_DIRECTORY[self.IMAGE_DIR_INDEX[SIN]])
          shutil.move(self.IMAGE_LIST[SIN],self.ISAVE_DIRECTORY[self.IMAGE_DIR_INDEX[SIN]])
          self.l0g(f"<<<<< moved {self.IMAGE_LIST[SIN]} to {self.ISAVE_DIRECTORY[self.IMAGE_DIR_INDEX[SIN]]} >>>>>")
  ######################################################################################################################################### idrop
  def idrop(self,s):
    if not self.MARKED:
      if self.MARKED_FILES[self.IMAGE_INDEX]==-1:
        self.l0g(f"<<<<< unmarking from drop {self.IMAGE_LIST[self.IMAGE_INDEX]} >>>>>")
        self.MARKED_FILES[self.IMAGE_INDEX]=0
        self.loadimage()
        return
      else:
        self.l0g(f"<<<<< marked to drop {self.IMAGE_LIST[self.IMAGE_INDEX]} >>>>>")
        self.MARKED_FILES[self.IMAGE_INDEX]=-1
      if self.LAST_DIRECTION:
        self.right(self)
      else:

        self.left(self)
    else:
      for DIN,VAL in enumerate(self.MARKED_FILES):
        if VAL==-1:
          if not os.path.exists(self.IDROP_DIRECTORY[self.IMAGE_DIR_INDEX[DIN]]):
            os.mkdir(self.IDROP_DIRECTORY[self.IMAGE_DIR_INDEX[DIN]])
          shutil.move(self.IMAGE_LIST[DIN],self.IDROP_DIRECTORY[self.IMAGE_DIR_INDEX[DIN]])
          self.l0g(f"<<<<< moved {self.IMAGE_LIST[DIN]} to {self.IDROP_DIRECTORY[self.IMAGE_DIR_INDEX[DIN]]} >>>>>")
  ######################################################################################################################################### shuffling
  def shuffling(self,s):
    self.USER_USERSHUF=not self.USER_USERSHUF
    if self.USER_USERSHUF:
      self.getfilelist()
      self.loadimage()
      self.l0g(f"<<<<< image shuffling enabled >>>>>")
    else:
      self.l0g(f"<<<<< image shuffling disabled >>>>>")
  ######################################################################################################################################### escaped
  def escaped(self,s):
    self.root.destroy()
    sys.exit(0)
  ######################################################################################################################################### markedlist
  def markedlist(self,s):
    self.l0g(f"<<<<< batch processing marked list >>>>>")
    self.MARKED=True
    self.isave(self)
    self.idrop(self)
    self.MARKED=False
    self.REFRESH=0
    if self.LAST_DIRECTION:
      self.right(self)
    else:
      self.left(self)
  ######################################################################################################################################### autogrid <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< autogrid
  def ripgrid(self,s):
    self.l0g(f'<<< ripgrid >>>')
    try:
      icount=0
      for __y in range(self.GY):
        for __x in range(self.GX):
          self.xy[0]=__x; self.xy[1]=__y; self.movecell()
          self.image_gridcell.save(f'ripgrid_{str(self.basename).zfill(8)}_{str(icount).zfill(4)}_.png')
          icount+=1
      ######################
      self.basename+=1
      self.GRID(self)
      self.AUTO_GRID=True
      if self.LAST_DIRECTION:
        self.right(self)
      else:
        self.left(self)
    except:
      self.l0g(f'error: ripgrid saving preview')
  ######################################################################################################################################### autogrid <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< autogrid
  def flipautogrid(self,s):
    self.AUTO_GRID=not self.AUTO_GRID
    self.l0g(f'<<< autogrid mode: {self.AUTO_GRID} >>>')
  ######################################################################################################################################### autogrid <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< autogrid
  def autogrid(self,s):
    self.l0g(f'<<< autogrid mode: enabled >>>')
    #######################################################################################################################################
    if not self.REDIMENSION==2:
      self.REDIMENSION=2
      self.loadimage()
    #######################################################################################################################################
    reso=self.calcreso(f'{self.image.width}x{self.image.height}')
    agx=0; agy=0;
    try:
      AGX,AGY=[reso[x] for x in reso.keys()]
    except:
      AGXY=[reso[x] for x in reso.keys()]
      AGX=AGXY; AGY=AGXY
    if 1024 in AGX and 1024 in AGY:
      agx=self.image.width/1024
      agy=self.image.height/1024
    elif 1024 in AGX and 768 in AGY:
      agx=self.image.width/1024
      agy=self.image.height/768
    elif 768 in AGX and 1024 in AGY:
      agx=self.image.width/768
      agy=self.image.height/1024
    elif 768 in AGX and 768 in AGY:
      agx=self.image.width/768
      agy=self.image.height/768
    elif 768 in AGX and 512 in AGY:
      agx=self.image.width/768
      agy=self.image.height/512
    elif 512 in AGX and 768 in AGY:
      agx=self.image.width/512
      agy=self.image.height/768
    elif 512 in AGX and 512 in AGY:
      agx=self.image.width/512
      agy=self.image.height/512
    else:
      inx=0; iny=-1;
      for n in range(len(reso[self.image.width])):
        inx-=1
        agx=self.image.width/reso[self.image.width][inx]
        agy=self.image.height/reso[self.image.height][iny]
        if agx>=agy:
          print(f'{agx}x{agy}')
          break
    self.gx=int(agx)
    self.GX=int(agx)
    self.gy=int(agy)
    self.GY=int(agy)
    _x=self.root.winfo_screenwidth()/self.GX
    _y=self.root.winfo_screenheight()/self.GY
    #######################################################################################################################################
    [ self.canvas.delete(x) for x in self.canvas.find_all() if not 'activeimage' in self.canvas.itemconfig(x) ]
    #######################################################################################################################################
    self.cellrect[0]=self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth()-1,self.root.winfo_screenheight()-1, outline='red2', width=1)
    _x=self.root.winfo_screenwidth()/self.GX; _y=self.root.winfo_screenheight()/self.GY
    for Y in range(self.gy+1):
      for X in range(self.gx):
        self.cellrect[1].append(self.canvas.create_rectangle((_x*X),(_y*Y),(_x*X)+_x,(_y*Y)+_y,outline=self.autocolor(1),width=1))
        self.cellrect[2].append(self.canvas.create_rectangle((_x*X)+3,(_y*Y)+3,(_x*X)+_x-2,(_y*Y)+_y-2,outline=self.autocolor(0),width=4))
    #######################################################################################################################################
    x_x=self.root.winfo_screenwidth()/2
    y_y=self.root.winfo_screenheight()/2
    #######################################################################################################################################
    if self.RENDER_TEXT:
      if self.MARKED_FILES[self.IMAGE_INDEX]==0:    COLOR=self.NORMAL_TEXT_COLOR
      elif self.MARKED_FILES[self.IMAGE_INDEX]==1:  COLOR='green'
      elif self.MARKED_FILES[self.IMAGE_INDEX]==-1: COLOR='red'
      #####################################################################################################################################
      Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],self.REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,self.root.winfo_screenwidth()-self.image.width,self.root.winfo_screenheight()-self.image.height,self.XX,self.YY,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
      self.l0g('break <-> here here here here here here here here here here here here here here here here here here here here here here here')
      #####################################################################################################################################
      self.canvas.create_text(x_x,85,text=Buffer,fill=COLOR,justify='center'); self.root.title(Buffer)
    #######################################################################################################################################
    self.root.update() ####################################################################################################################
    self.AUTO_GRID=False
    self.GRID_MODE=True
    self.grid(self)    
  ######################################################################################################################################### autopump
  def autopump(self,s):
    self.PUMP_AUTO = not self.PUMP_AUTO
    if self.PUMP_AUTO:
      while self.PUMP_AUTO:
        self.right(self)
        if self.PUMP_INTERVAL < 0.01: self.PUMP_INTERVAL+=0.5
        sleep(self.PUMP_INTERVAL)
      self.l0g(self.PUMP_AUTO)
  ######################################################################################################################################### redimension
  def redimension(self,s):
    self.canvas.delete('all')
    self.REDIMENSION+=1
    if self.REDIMENSION>4: self.REDIMENSION=0
    self.loadimage()
  ######################################################################################################################################### loadimage <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< loadimage
  def loadimage(self):
    self.canvas.delete('all')
    try:
      try:
        self.image=Image.open(self.IMAGE_LIST[self.IMAGE_INDEX])
      except:
        pass
      IMG_X_OG=self.image.width
      IMG_Y_OG=self.image.height
      x=self.root.winfo_screenwidth()
      y=self.root.winfo_screenheight()
      xx=self.image.width
      yy=self.image.height
      REDIMENSION=""
      #####################################################################################################################################
      if self.REDIMENSION==0:
        self.canvas.delete('all')
        if xx>yy:
          rr=xx/yy
          if xx>x:
            REDIMENSION="[ image x screen-constrained ]"
            xx=x
            yy=int(x*rr)
          if yy>y:
            REDIMENSION="[ image y screen-constrained ]"
            yy=y
            xx=int(y*rr)
        else:
          rr=yy/xx
          if yy>y:
            REDIMENSION="[ image y screen-constrained ]"
            yy=y
            xx=int(y*rr)
          if xx>x:
            REDIMENSION="[ image x screen-constrained ]"
            xx=x
            yy=int(x*rr)
        try:
          self.resized_image=self.image.resize((xx,yy),Image.Resampling.LANCZOS)
          self.photo_resized=ImageTk.PhotoImage(self.resized_image)
          self.canvas.create_image(x/2-xx/2,0,anchor=NW,image=self.photo_resized)
        except:
          if self.LAST_DIRECTION:
            self.right(self)
          else:
            self.left(self)
        self.XX=xx; self.YY=yy
        Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,x-IMG_X_OG,y-IMG_Y_OG,xx,yy,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
        Buffer+= f'\n{self.xy[0]}x{self.GX} / {self.xy[1]}y{self.GY}'
        if self.RENDER_TEXT:
          COLOR=''
          if self.MARKED_FILES[self.IMAGE_INDEX]==0:
            COLOR=self.NORMAL_TEXT_COLOR
          elif self.MARKED_FILES[self.IMAGE_INDEX]==1:
            COLOR='green'
            self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
          elif self.MARKED_FILES[self.IMAGE_INDEX]==-1:
            COLOR='red'
            self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
          self.texting=self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2, 85, text=Buffer,fill=COLOR,justify='center',font=(self.NORMAL_TEXT_FONT, self.NORMAL_TEXT_SIZE))
        self.root.title(Buffer)
        self.root.update()
      #####################################################################################################################################
      elif self.REDIMENSION==1:
        self.canvas.delete('all')
        REDIMENSION="[ image x screen-constrained ]"
        xx=self.image.width
        yy=self.image.height
        if xx>yy:
          rr=xx/yy
          if xx>x:
            xx=x
            yy=int(y*rr)
          else:
            xx=x
            yy=int(x/rr)
        else:
          rr=xx/yy
          xx=x
          yy=int(x/rr)
        offset=0
        if yy>self.root.winfo_screenheight():
          for i in range(100):
            if not self.REDIMENSION==1:
              self.canvas.delete('all')
              sleep(0.1)
              self.loadimage()
              break
            offset=int(i*(yy-self.root.winfo_screenheight())/100)
            self.resized_image=self.image.resize((xx,yy),Image.LANCZOS)
            self.cropped_image=self.resized_image.crop([0,0+offset,x,y+offset])
            self.photo_resized=ImageTk.PhotoImage(self.cropped_image)
            self.canvas.create_image(0,0,anchor=NW,image=self.photo_resized)
            self.canvas.configure(bg='black')
            self.XX=xx; self.YY=yy
            Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,x-IMG_X_OG,y-IMG_Y_OG,xx,yy,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
            Buffer+= f'\n{self.xy[0]}x{self.GX} / {self.xy[1]}y{self.GY}'
            if self.RENDER_TEXT:
              COLOR=''
              if self.MARKED_FILES[self.IMAGE_INDEX]==0:
                COLOR=self.NORMAL_TEXT_COLOR
              elif self.MARKED_FILES[self.IMAGE_INDEX]==1:
                COLOR='green'
                self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
              elif self.MARKED_FILES[self.IMAGE_INDEX]==-1:
                COLOR='red'
                self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
              self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2, 85, text=Buffer,fill=COLOR,justify='center',font=("Arial", 25))
            self.root.title(Buffer)
            self.l0g(f"{offset} / {x} - {i}")
            self.root.update()
        else:
          self.resized_image=self.image.resize((xx,yy),Image.LANCZOS)
          self.photo_resized=ImageTk.PhotoImage(self.resized_image)
          self.canvas.create_image(0,0,anchor=NW,image=self.photo_resized)
          self.canvas.delete('all')
          self.canvas.configure(bg='black')
          self.XX=xx; self.YY=yy
          Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,x-IMG_X_OG,y-IMG_Y_OG,xx,yy,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
          Buffer+= f'\n{self.xy[0]}x{self.GX} / {self.xy[1]}y{self.GY}'
          if self.RENDER_TEXT:
              COLOR=''
              if self.MARKED_FILES[self.IMAGE_INDEX]==0:
                COLOR=self.NORMAL_TEXT_COLOR
              elif self.MARKED_FILES[self.IMAGE_INDEX]==1:
                COLOR='green'
                self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
              elif self.MARKED_FILES[self.IMAGE_INDEX]==-1:
                COLOR='red'
                self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
              self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2, 85, text=Buffer,fill=COLOR,justify='center',font=("Arial", 25))
          self.root.title(Buffer)
          try:
            self.l0g(f"{offset} / {x} - {i}")
          except:
            pass
          if self.REDIMENSION==1:
            self.root.update()
      #####################################################################################################################################
      elif self.REDIMENSION==2:
        self.canvas.delete('all')
        REDIMENSION="[ image x,y screen-stretched ]"
        self.resized_image=self.image.resize((self.root.winfo_screenwidth(),self.root.winfo_screenheight()),Image.LANCZOS)
        self.photo_resized=ImageTk.PhotoImage(self.resized_image)
        self.canvas.create_image(0,0,anchor=NW,image=self.photo_resized)
        self.XX=xx; self.YY=yy
        Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,x-IMG_X_OG,y-IMG_Y_OG,xx,yy,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
        Buffer+= f'\n{self.xy[0]}x{self.GX} / {self.xy[1]}y{self.GY}'
        if self.RENDER_TEXT:
          COLOR=''
          if self.MARKED_FILES[self.IMAGE_INDEX]==0:
            COLOR=self.NORMAL_TEXT_COLOR
          elif self.MARKED_FILES[self.IMAGE_INDEX]==1:
            COLOR='green'
            self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
          elif self.MARKED_FILES[self.IMAGE_INDEX]==-1:
            COLOR='red'
            self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
          self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2, 85, text=Buffer,fill=COLOR,justify='center',font=("Arial", 25))
        self.root.title(Buffer)
        self.root.update()
        if self.AUTO_GRID:
          self.autogrid(self)
      #####################################################################################################################################
      elif self.REDIMENSION==3:
        self.canvas.delete('all')
        REDIMENSION="[ screen x,y image-thumbnail ]"
        self.image.thumbnail((1680,1050),resample=Image.LANCZOS)
        self.image.save('thumbnail.jpg')
        self.image=Image.open('thumbnail.jpg')
        self.photo=ImageTk.PhotoImage(self.image)
        xx=self.image.width
        yy=self.image.height
        self.canvas.create_image(x/2-xx/2,0,anchor=NW,image=self.photo)
        self.XX=xx; self.YY=yy
        Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,x-IMG_X_OG,y-IMG_Y_OG,xx,yy,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
        Buffer+= f'\n{self.xy[0]}x{self.GX} / {self.xy[1]}y{self.GY}'
        if self.RENDER_TEXT:
          COLOR=''
          if self.MARKED_FILES[self.IMAGE_INDEX]==0:
            COLOR=self.NORMAL_TEXT_COLOR
          elif self.MARKED_FILES[self.IMAGE_INDEX]==1:
            COLOR='green'
            self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
          elif self.MARKED_FILES[self.IMAGE_INDEX]==-1:
            COLOR='red'
            self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
          self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2, 85, text=Buffer,fill=COLOR,justify='center',font=("Arial", 25))
        self.root.title(Buffer)
        self.root.update()
      #####################################################################################################################################
      elif self.REDIMENSION==4:
        self.canvas.delete('all')
        REDIMENSION="[ image-original ]"
        self.photo=ImageTk.PhotoImage(self.image)
        self.canvas.create_image(x/2-xx/2,0,anchor=NW,image=self.photo)
        self.XX=xx; self.YY=yy
        Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,x-IMG_X_OG,y-IMG_Y_OG,xx,yy,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
        Buffer+= f'\n{self.xy[0]}x{self.GX} / {self.xy[1]}y{self.GY}'
        if self.RENDER_TEXT:
          COLOR=''
          if self.MARKED_FILES[self.IMAGE_INDEX]==0:
            COLOR=self.NORMAL_TEXT_COLOR
          elif self.MARKED_FILES[self.IMAGE_INDEX]==1:
            COLOR='green'
            self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
          elif self.MARKED_FILES[self.IMAGE_INDEX]==-1:
            COLOR='red'
            self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
          self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2, 85, text=Buffer,fill=COLOR,justify='center')
        self.root.title(Buffer)
        self.root.update()
      #####################################################################################################################################
      self.canvas.configure(bg='black')
      global Name
      Name =''
      if self.RENDER_TEXT:
        COLOR=''
        if self.MARKED_FILES[self.IMAGE_INDEX]==0:
          COLOR=self.NORMAL_TEXT_COLOR
        elif self.MARKED_FILES[self.IMAGE_INDEX]==1:
          COLOR='green'
          self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
        elif self.MARKED_FILES[self.IMAGE_INDEX]==-1:
          COLOR='red'
          self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth(),self.root.winfo_screenheight(), outline=COLOR, width=25,)
        self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2,85,text=Name,fill=COLOR,justify='center',font=(self.NORMAL_TEXT_FONT, self.NORMAL_TEXT_SIZE))
      self.root.title(Name)
      self.root.update()
    except IOError:
      self.l0g(f"error: non-picture, skipping past - {self.IMAGE_LIST[self.IMAGE_INDEX]}")
      if self.LAST_DIRECTION:
        self.right(self)
      else:
        self.left(self)
    self.l0g('<< dr1p1m4g3 >> screen: {}x{} - image: {}x{} - file: {}/{} - interval: {} - filename: {}'.format(self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL,self.IMAGE_LIST[self.IMAGE_INDEX]))
  ######################################################################################################################################### log
  def log(self,s):
    f=open(self.logfile,'a')
    f.write(f'{s}\n')
    f.close()
  ######################################################################################################################################### calcreso <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< calcreso
  def calcreso(self,s):
    x,y=s.split('x');X=[];Y=[]
    for i in range(256,1024):
      if not (int(x)/i) % 1: X.append(i)
      if not (int(y)/i) % 1: Y.append(i)
    return {int(x):X,int(y):Y}
  ######################################################################################################################################### getfilelist <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< getfilelist
  def getfilelist(self):
    # self.IMAGE_LIST=[ x for x in Path(self.IMAGE_DIR+'/').rglob('*') if not str(x).endswith('.txt') and not "intermediates" in x.name ]
    if self.REFRESH==0:
      self.REFRESH=1
      FILE_LIST=[]
      self.IMAGE_DIR_INDEX=[]
      for i,_ in enumerate(self.DIR_IMAGE_LIST):
        self.l0g(f'<<< generating image list recursively from base directory: {_}/* >>>')
        _FILE_LIST=[ x for x in Path(_+'/').rglob('*') ]
        FILE_LIST+=_FILE_LIST
        self.IMAGE_DIR_INDEX+=[i]*len(_FILE_LIST)
      self.IMAGE_LIST=[]
      IMAGE_DIR_INDEX=[]
      self.resodb=[]
      for i,x in enumerate(FILE_LIST):
          try:
              # if is_file_an_image(str(x)):
              self.IMAGE_LIST.append(x)
              IMAGE_DIR_INDEX+=[self.IMAGE_DIR_INDEX[i]]
              self.l0g(f'added: {str(x)}')
              reso_x,reso_y=Image.open(x).size
          except Exception as e:
              self.l0g(f'skipped: {str(x)} - reason: {e}')
      #######################################################
      try:
        self.l0g('<<< writing image resolution database >>>')
        self.resodb=sorted(set(self.resodb)) # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        #for _ in self.resodb: self.log(_)   # <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      except Exception as e:
        self.l0g('error writing image resolution database: {e}')
      #######################################################
      self.root.deiconify()
      #######################################################
      self.IMAGE_DIR_INDEX=IMAGE_DIR_INDEX
      self.MARKED_FILES=[0]*len(IMAGE_DIR_INDEX)
    if self.USER_USERSHUF:
      shuffle(self.IMAGE_LIST)
      self.IMAGE_INDEX=randint(0,len(self.IMAGE_LIST)-1)
    self.l0g(f'index:{self.IMAGE_LIST[self.IMAGE_INDEX]}/{len(self.IMAGE_LIST)} - filename:{self.IMAGE_LIST[self.IMAGE_INDEX]} - size:{self.image.size}: [ width:{self.image.width} / height:{self.image.height} ]')
    self.IMAGE_LIST=sorted(self.IMAGE_LIST)
  ######################################################################################################################################### movecell <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< movecell
  def movecell(self):
    _x=self.root.winfo_screenwidth()/self.GX
    _y=self.root.winfo_screenheight()/self.GY
    #########################################
    try:
      self.canvas.delete(self.moverect)
    except:
      pass
    #######

    [ self.canvas.delete(x) for x in self.canvas.find_all() if not 'activeimage' in self.canvas.itemconfig(x) ]

    self.moverect = self.canvas.create_rectangle((self.xy[0]*_x)+5,(self.xy[1]*_y)+5,(self.xy[0]*_x)+_x-5,(self.xy[1]*_y)+_y-5,outline=self.autocolor(2),width=8)
    _x=self.image.width/self.GX
    _y=self.image.height/self.GY
    self.image_gridcell=self.image.crop([ (_x*self.xy[0]),(_y*self.xy[1]),(_x*self.xy[0])+_x,(_y*self.xy[1])+_y ])
    self.image_preview=ImageTk.PhotoImage(self.image_gridcell)
    x_x=self.root.winfo_screenwidth()/2
    y_y=self.root.winfo_screenheight()/2

    self.cellrect[0]=self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth()-1,self.root.winfo_screenheight()-1, outline='red2', width=1)
    _x=self.root.winfo_screenwidth()/self.GX; _y=self.root.winfo_screenheight()/self.GY
    for Y in range(self.gy+1):
      for X in range(self.gx):
        self.cellrect[1].append(self.canvas.create_rectangle((_x*X),(_y*Y),(_x*X)+_x,(_y*Y)+_y,outline=self.autocolor(1),width=1))
        self.cellrect[2].append(self.canvas.create_rectangle((_x*X)+3,(_y*Y)+3,(_x*X)+_x-2,(_y*Y)+_y-2,outline=self.autocolor(0),width=4))

    self.preview=self.canvas.create_image(x_x,y_y,image=self.image_preview)

    if self.RENDER_TEXT:
      COLOR=''
      if self.MARKED_FILES[self.IMAGE_INDEX]==0:
        COLOR=self.NORMAL_TEXT_COLOR
      elif self.MARKED_FILES[self.IMAGE_INDEX]==1:
        COLOR='green'
      elif self.MARKED_FILES[self.IMAGE_INDEX]==-1:
        COLOR='red'
      Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],self.REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,self.root.winfo_screenwidth()-self.image.width,self.root.winfo_screenheight()-self.image.height,self.XX,self.YY,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
      Buffer+= f'\n{self.xy[0]}x{self.GX} / {self.xy[1]}y{self.GY} - {self.image.width/self.GX}x{self.image.height/self.GY} '

      self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2, 85, text=Buffer,fill=COLOR,justify='center')
      self.root.title(Buffer)

    self.root.update()
  ######################################################################################################################################### up
  def up(self,s):
    if not self.GRID_MODE:
    ######################
      self.PUMP_INTERVAL+=0.01
    #####
    else:
    #####
      self.xy[1]-=1
      if self.xy[1]<0: self.xy[1]=0
      ################
      self.movecell()
  ######################################################################################################################################### down
  def down(self,s):
    if not self.GRID_MODE:
    ######################
      self.PUMP_INTERVAL-=0.01
    #####
    else:
    #####
      self.xy[1]+=1
      if self.xy[1]>self.gy: self.xy[1]=self.gy
      ######################
      self.movecell()
  ######################################################################################################################################### left
  def left(self,s):
    if not self.GRID_MODE:
    ######################
      self.LAST_DIRECTION=False
      self.IMAGE_INDEX-=1
      self.getfilelist()
      if self.IMAGE_INDEX<0:
        self.IMAGE_INDEX=len(self.IMAGE_LIST)-1
      self.loadimage()
    #####
    else:
    #####
      self.xy[0]-=1
      if self.xy[0]<0: self.xy[0]=0
      ################
      self.movecell()
  ######################################################################################################################################### right
  def right(self,s):
    if not self.GRID_MODE:
    ######################
      self.LAST_DIRECTION=True
      self.IMAGE_INDEX+=1
      if self.IMAGE_INDEX==len(self.IMAGE_LIST):
        self.IMAGE_INDEX=0
      self.getfilelist()
      self.loadimage()
    #####
    else:
    #####
      self.xy[0]+=1
      if self.xy[0]>=self.gx: self.xy[0]=self.gx-1
      ######################
      self.movecell()
  ######################################################################################################################################### grid <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< grid
  def grid(self,s):
  #################
    if not self.GRID_MODE:
      self.GRID_MODE=True
    if not s in ['x','y', 'X', 'Y']:
      self.REDIMENSION=2
      self.loadimage()
    elif s in ['X', 'Y']:
      for _ in self.cellrect[1]:
        self.l0g(f'<<< deleting grid rect: {_} >>>')
        self.canvas.delete(_)
      for _ in self.cellrect[2]:
        self.l0g(f'<<< deleting grid rect: {_} >>>')
        self.canvas.delete(_)
    self.cellrect[0]=self.canvas.create_rectangle(0,0,self.root.winfo_screenwidth()-1,self.root.winfo_screenheight()-1, outline='red2', width=1)
    _x=self.root.winfo_screenwidth()/self.GX; _y=self.root.winfo_screenheight()/self.GY
    for Y in range(self.gy+1):
      for X in range(self.gx):
        self.cellrect[1].append(self.canvas.create_rectangle((_x*X),(_y*Y),(_x*X)+_x,(_y*Y)+_y,outline=self.autocolor(1),width=1))
        self.cellrect[2].append(self.canvas.create_rectangle((_x*X)+3,(_y*Y)+3,(_x*X)+_x-2,(_y*Y)+_y-2,outline=self.autocolor(0),width=4))
    self.root.update()
    self.l0g(f'<<< grid mode: enabled >>>')
  ######################################################################################################################################### GRID
  def halting(self,s):
    print(f'gx{self.gx}GX{self.GX}xy[0]{self.xy[0]}/gy{self.gy}GY{self.GY}xy[1]{self.xy[1]}')
    pass
  ######################################################################################################################################### GRID
  def GRID(self,s):
    if self.GRID_MODE:
      self.GRID_MODE=False
      self.xy=[0,0]
      self.gy=1
      self.gx=0
      self.loadimage()
      self.root.update()
      self.l0g(f'<<< grid mode: disabled >>>')
  ######################################################################################################################################### gridx
  def gridx(self,s):
    ######################
    if not self.GRID_MODE:
      self.REDIMENSION=2
      self.loadimage()
      self.GRID_MODE=True
    ######################
    self.gx+=1
    self.grid('x')
    self.l0g(f'<<< grid mode: added x grid cell. x={self.gx},y={self.gy} >>>')
  ######################################################################################################################################### gridy
  def gridy(self,s):
    ######################
    if not self.GRID_MODE:
      self.REDIMENSION=2
      self.loadimage()
      self.GRID_MODE=True
    ######################
    self.gy+=1
    self.grid('y')
    self.l0g(f'<<< grid mode: added y grid cell. x={self.gx},y={self.gy} >>>')
  ######################################################################################################################################### gridX
  def gridX(self,s):
    ######################
    if not self.GRID_MODE:
      self.REDIMENSION=2
      self.loadimage()
      self.GRID_MODE=True
    ######################
    self.gx-=1
    if self.gx < 0: self.gx=0
    self.grid('X')
    self.l0g(f'<<< grid mode: removed x cell. x={self.gx},y={self.gy} >>>')
  ######################################################################################################################################### gridY
  def gridY(self,s):
    ######################
    if not self.GRID_MODE:
      self.REDIMENSION=2
      self.loadimage()
      self.GRID_MODE=True
    ######################
    self.gy-=1
    if self.gy < 0: self.gy=0
    self.grid('Y')
    self.l0g(f'<<< grid mode: removed y cell. x={self.gx},y={self.gy} >>>')
  ######################################################################################################################################### grid_cell_up_y
  def grid_cell_up_y(self,s):
    ######################
    if not self.GRID_MODE:
      self.REDIMENSION=2
      self.loadimage()
      self.GRID_MODE=True
    ######################
    self.GY+=1
    self.l0g(f'<<< grid mode: y division cell height increased. x={self.GX},y={self.GY} >>>')
    if self.RENDER_TEXT:
      COLOR=''
      if self.MARKED_FILES[self.IMAGE_INDEX]==0:
        COLOR=self.NORMAL_TEXT_COLOR
      elif self.MARKED_FILES[self.IMAGE_INDEX]==1:
        COLOR='green'
      elif self.MARKED_FILES[self.IMAGE_INDEX]==-1:
        COLOR='red'
      Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],self.REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,self.root.winfo_screenwidth()-self.image.width,self.root.winfo_screenheight()-self.image.height,self.XX,self.YY,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
      Buffer+= f'\n{self.xy[0]}x{self.GX} / {self.xy[1]}y{self.GY}'
      [ self.canvas.delete(x) for x in self.canvas.find_all() if not 'activeimage' in self.canvas.itemconfig(x) ]
      self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2, 85, text=Buffer,fill=COLOR,justify='center')
      self.root.title(Buffer)
      self.root.update()
      self.grid(self)
  ######################################################################################################################################### grid_cell_down_y
  def grid_cell_down_y(self,s):
    ######################
    if not self.GRID_MODE:
      self.REDIMENSION=2
      self.loadimage()
      self.GRID_MODE=True
    ######################
    self.GY-=1
    self.l0g(f'<<< grid mode: y division cell height decreased. x={self.GX},y={self.GY} >>>')
    if self.RENDER_TEXT:
      COLOR=''
      if self.MARKED_FILES[self.IMAGE_INDEX]==0:
        COLOR=self.NORMAL_TEXT_COLOR
      elif self.MARKED_FILES[self.IMAGE_INDEX]==1:
        COLOR='green'
      elif self.MARKED_FILES[self.IMAGE_INDEX]==-1:
        COLOR='red'
      Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],self.REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,self.root.winfo_screenwidth()-self.image.width,self.root.winfo_screenheight()-self.image.height,self.XX,self.YY,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
      Buffer+= f'\n{self.xy[0]}x{self.GX} / {self.xy[1]}y{self.GY}'
      [ self.canvas.delete(x) for x in self.canvas.find_all() if not 'activeimage' in self.canvas.itemconfig(x) ]
      self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2, 85, text=Buffer,fill=COLOR,justify='center')
      self.root.title(Buffer)
      self.root.update()
      self.grid(self)
  ######################################################################################################################################### grid_cell_up_x
  def grid_cell_up_x(self,s):
    ######################
    if not self.GRID_MODE:
      self.REDIMENSION=2
      self.loadimage()
      self.GRID_MODE=True
    ######################
    self.GX-=1
    self.l0g(f'<<< grid mode: x division cell width decreased. x={self.GX},y={self.GY} >>>')
    if self.RENDER_TEXT:
      COLOR=''
      if self.MARKED_FILES[self.IMAGE_INDEX]==0:
        COLOR=self.NORMAL_TEXT_COLOR
      elif self.MARKED_FILES[self.IMAGE_INDEX]==1:
        COLOR='green'
      elif self.MARKED_FILES[self.IMAGE_INDEX]==-1:
        COLOR='red'
      Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],self.REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,self.root.winfo_screenwidth()-self.image.width,self.root.winfo_screenheight()-self.image.height,self.XX,self.YY,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
      Buffer+= f'\n{self.xy[0]}x{self.GX} / {self.xy[1]}y{self.GY} - {self.image.width/self.GX}x{self.image.height/self.GY} '
      [ self.canvas.delete(x) for x in self.canvas.find_all() if not 'activeimage' in self.canvas.itemconfig(x) ]
      self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2, 85, text=Buffer,fill=COLOR,justify='center')
      self.root.title(Buffer)
      self.root.update()
      self.grid(self)
  ######################################################################################################################################### grid_cell_down_x
  def grid_cell_down_x(self,s):
    ######################
    if not self.GRID_MODE:
      self.REDIMENSION=2
      self.loadimage()
      self.GRID_MODE=True
    ######################
    self.GX+=1
    self.l0g(f'<<< grid mode: x division cell width increased. x={self.GX},y={self.GY} >>>')
    if self.RENDER_TEXT:
      COLOR=''
      if self.MARKED_FILES[self.IMAGE_INDEX]==0:
        COLOR=self.NORMAL_TEXT_COLOR
      elif self.MARKED_FILES[self.IMAGE_INDEX]==1:
        COLOR='green'
      elif self.MARKED_FILES[self.IMAGE_INDEX]==-1:
        COLOR='red'
      Buffer = 'filename: {}\nredimension: {} - screen: {}x{} - image: {}x{} - diff: {}x{} - resize: {}x{}\nfile: {}/{} - interval: {}'.format(self.IMAGE_LIST[self.IMAGE_INDEX],self.REDIMENSION,self.root.winfo_screenwidth(),self.root.winfo_screenheight(),self.image.width,self.image.height,self.root.winfo_screenwidth()-self.image.width,self.root.winfo_screenheight()-self.image.height,self.XX,self.YY,self.IMAGE_INDEX,len(self.IMAGE_LIST)-1,self.PUMP_INTERVAL)
      Buffer+= f'\n{self.xy[0]}x{self.GX} / {self.xy[1]}y{self.GY}'
      [ self.canvas.delete(x) for x in self.canvas.find_all() if not 'activeimage' in self.canvas.itemconfig(x) ]
      self.texting=self.canvas.create_text(self.root.winfo_screenwidth()/2, 85, text=Buffer,fill=COLOR,justify='center')
      self.root.title(Buffer)
      self.root.update()
      self.grid(self)
  ######################################################################################################################################### main <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< mainloop with binds
  def main(self):
    #######################################################################################################################################
    try:
      Name='<< dr1p1m4g3 >>'
      self.root=Tk(className=Name)
      self.NORMAL_TEXT_FONTS=font.families()
      self.root.attributes('-fullscreen',True)
      self.root.eval('tk::PlaceWindow . center')
      #self.root.overrideredirect(True)
      self.root.wm_attributes("-topmost",True)
      self.root.withdraw()
      #self.root.wm_attributes("-transparent",True)
      #self.root.config(bg='systemTransparent')
      self.image=Image.new(mode='RGB', size=(self.root.winfo_screenwidth(),self.root.winfo_screenheight()))
      self.photo=ImageTk.PhotoImage(self.image)
      self.canvas=Canvas(self.root,width=self.root.winfo_screenwidth(),height=self.root.winfo_screenheight(),bd=0,highlightthickness=0)
      #self.canvas=Canvas(self.root,width=self.root.winfo_screenwidth(),height=self.root.winfo_screenheight(),bd=2,bg='white',highlightthickness=1,highlightbackground='white')
      self.canvas.pack(fill="both",expand=True)
      self.REDIMENSION+=self.USER_RENDMODE
      self.IMAGE_INDEX=(0+int(self.USER_IMGINDEX))
      self.PUMP_AUTO=self.USER_PUMPMODE
      self.getfilelist()
      self.canvas.bind("<z>",self.ripgrid)
      self.canvas.bind("<a>",self.flipautogrid)
      self.canvas.bind("<m>",self.shuffling)
      self.canvas.bind("<backslash>",self.autogrid)
      self.canvas.bind("<g>",self.grid)
      self.canvas.bind("<G>",self.GRID)
      self.canvas.bind("<h>",self.halting)      
      self.canvas.bind("<x>",self.gridx)
      self.canvas.bind("<y>",self.gridy)
      self.canvas.bind("<X>",self.gridX)
      self.canvas.bind("<Y>",self.gridY)
      self.canvas.bind("<i>",self.markedlist)
      self.canvas.bind("<p>",self.autopump)
      self.canvas.bind("<r>",self.redimension)
      self.canvas.bind("<t>",self.fliptext)
      self.canvas.bind("<Up>",self.up)
      self.canvas.bind("<Down>",self.down)
      self.canvas.bind("<Left>",self.left)
      self.canvas.bind("<Right>",self.right)
      self.canvas.bind("<Up>",self.up)
      self.canvas.bind("<Down>",self.down)
      self.canvas.bind("<Left>",self.left)
      self.canvas.bind("<Right>",self.right)
      self.canvas.bind("<comma>",self.grid_cell_up_x)
      self.canvas.bind("<period>",self.grid_cell_down_x)
      self.canvas.bind("<greater>",self.grid_cell_up_y)
      self.canvas.bind("<less>",self.grid_cell_down_y)
      self.canvas.bind("<grave>",self.randofontcolors)
      self.canvas.bind("<s>",self.isave)
      self.canvas.bind("<d>",self.idrop)
      self.canvas.bind("<q>",self.escaped)
      self.canvas.focus_set()
      self.loadimage()
      sleep(0.1)
      self.root.wm_attributes('-fullscreen', True)
      self.root.mainloop()
    #######################################################################################################################################
    except Exception as err:
      self.l0g(f"main(): {err}")
########################################################################################################################################### main
def main(screen):
    DIR_IMAGE_LIST=[]
    curses.start_color()
    curses.use_default_colors()
    curses.init_pair(1,5,0)
    curses.init_pair(2,4,0)
    curses.init_pair(3,6,0)
    curses.init_pair(4,3,0)
    ch, first, selected, paths = 0, 0, 0, [ x for x in listdir() if os.path.isdir(x) ]
    screen.erase()
    try:
      screen.addstr(0,0,'SELECT A BASE DIRECTORY',curses.color_pair(2))
      screen.addstr(': ',curses.color_pair(1))
      screen.addstr('<< ',curses.color_pair(4))
      screen.addstr('LEFT',curses.color_pair(3))
      screen.addstr('/',curses.color_pair(1))
      screen.addstr('RIGHT',curses.color_pair(3))
      screen.addstr('/',curses.color_pair(1))
      screen.addstr('ENTER',curses.color_pair(3))
      screen.addstr(' >>',curses.color_pair(4))
      screen.addstr(1,0,'[ ',curses.color_pair(1))
      screen.addstr("THE CURRENT DIRECTORY",curses.color_pair(2))
      screen.addstr(': ',curses.color_pair(1))
      screen.addstr(f"{os.getcwd()}",curses.color_pair(3))
      screen.addstr(' ]',curses.color_pair(1))
      screen.addstr(2,0,'',curses.color_pair(1))
    except Exception as e:
      pass
    screen.refresh()
    sleep(3)
    while ch != ascii.ESC:
        height, _ = screen.getmaxyx()
        screen.erase()
        screen.refresh()
        try:
          paths=sorted(paths)
          for y, filename in enumerate(paths[first : first+height]):
              screen.addstr(y, 0, filename, A_REVERSE * (selected == first + y))
        except:
          pass
        ch = screen.getch()
        selected += (ch == KEY_DOWN) - (ch == KEY_UP)
        selected = max(0, min(len(paths)-1, selected))
        first += (first <= selected - height) - (first > selected)
        if ch in [KEY_LEFT, KEY_RIGHT, KEY_ENTER, 32, 10, 13]:
          if not ch==10 and not ch==32:
            new_dir = '..' if ch == KEY_LEFT else paths[selected]
            if path.isdir(new_dir):
                chdir(new_dir)
                first, selected, paths = 0, 0, [ x for x in listdir() if os.path.isdir(x) ]
                paths=sorted(paths)
          elif ch==32:
            DIR_IMAGE_LIST.append(os.getcwd())
          elif ch==10:
            curses.nocbreak()
            curses.endwin()
            DIR_IMAGE_LIST.append(os.getcwd())
            return DIR_IMAGE_LIST
########################################################################################################################################### __name__
if __name__=="__main__":
  #########################################################################################################################################
  DEBUG=True
  if DEBUG:
    if STARTUP_DIRECTORY_OVERRIDE:
      USERPATH=STARTUP_DIRECTORY_OVERRIDE
    else:
      USERPATH=wrapper(main)
    IMGINDEX=int(3)
    RENDMODE=int(1)
    PUMPMODE=int(1)
    PUMPTIME=10
    USERSHUF=True
  else:
    USERPATH=wrapper(main)
    IMGINDEX=int(0)
    RENDMODE=int(1)
    PUMPMODE=int(0)
    PUMPTIME=float(0.5)
    USERSHUF=False
  #########################################################################################################################################
  if not DEBUG:
    try:
      USERPATH=str(sys.argv[1])
      print(f'[ specified user path: {USERPATH} ]')
    except:
      USERPATH=""
      print(f'[ no directory path was specified: defaulting to current directory and recursively ]')
  #########################################################################################################################################
  if not DEBUG:
    try:
      IMGINDEX=int(sys.argv[2])
      print(f'[ specified user inded: {IMGINDEX} ]')
    except:
      IMGINDEX=0
      print(f'[ no image index was specificed: defaulting to 0 ]')
  #########################################################################################################################################
  if not DEBUG:
    try:
      RENDMODE=int(sys.argv[3])
      print(f'[ specified rendering mode: {RENDMODE} ]')
    except:
      RENDMODE=0
      print(f'[ no render mode specified: defaulting to image x,y screen-constrained ]')
  #########################################################################################################################################
  if not DEBUG:
    try:
      PUMPMODE=int(sys.argv[4])
      print(f'[ specified user pump mode: {PUMPMODE} ]')
      try:
        PUMPTIME=float(sys.argv[5])
        print(f'[ specified user pump interval: {PUMPTIME} ]')
      except:
        PUMPTIME=0
        print(f'[ no pump mode interval: default to 0.5 second interval ]')
    except:
      print(f'[ no pump mode specified: defaulting to being turned off ]')
  #########################################################################################################################################
  if not DEBUG:
    try:
      USERSHUF=int(sys.argv[6])
      print(f'[ specified user image shuffle mode: {USERSHUF} ]')
    except:
      USERSHUF=False
      print(f'[ no shuffle mode specified: defaulting to being turned off ]')
  #########################################################################################################################################
  dr1p1m4g3=DR1P1M4G3(USERPATH,IMGINDEX,RENDMODE,PUMPMODE,PUMPTIME,USERSHUF)
####################################################################################################################################### EOF
###########################################################################################################################################
###########################################################################################################################################
###################MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMh+MMMMMMMMMMMMMMhsMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMm/ oMMMMMMMMMMMMMMm +NMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMy`  yMMMMMMMMMMMMMMM- -mMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMs+dMMMMMMMMMM+    sMMMMMMMMMMMMMMM-  `dMMMMMMMMMMms/NMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMM+ .omMMMMMM:     -MMMMMMMMMMMMMMo    `yMMMMMMMy: `dMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMM-   /dMMM+       sMMMMMMMMMMMMh      `hMMMNo`   sMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMd     :dm        `mMMMMMMMMMMN.       .NNo`    .MMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMM:      -         :MMMMMMMMMMs         :`      sMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMMs                 ymNMMMMMNm.                 NMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMMy                    `-/-`                   .MMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMMo                                            .NMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMNh+.                                               :sdMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMhso+:.                                                      `-/+syMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMM-                                                                 dMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMM`   `.:+/.                                              `/s+:.    sMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMNo   -oms.             .//-`               `:/:`            `+md+`  .hMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMNs`                        .odNdo.       .ohmd+`                        :dMMMMMMMMMMM#######################
###################MMMMMMMMMMNo`                             ..           .-                             :hMMMMMMMMM#######################
###################MMMMMMMMd+`                                                                             -sNMMMMMM#######################
###################MMMMMNs-                         `..                          `/-.                        `+dMMMM#######################
###################MMNy:                       ./sdNMMMh:                      `sNMMMNds/.                      .odM#######################
###################M+                       :ymMMMMMMMMMMh.                   +NMMMMMMMMMMmo-                      /#######################
###################MMh:                  .sNMMMMMMMMMMMMMMN-                `hMMMMMMMMMMMMMMMm+`                 :hM#######################
###################MMMMd:`       ``-:+shmMMMMMMMMMMMMMMMMMMN.               hMMMMMMMMMMMMMMMMMMMmhs+/-..``````./dMMM#######################
###################MMMMMMMMNNNNNNMMMMMMMMMMMMMMMMMMMMMMMMMMMo              .MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMy              .MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMN.             /MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMN+`         `+NMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMNs.    -hMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM#######################
###################MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMdyymMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM#######################
